unit main;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, ComCtrls,
  Clipbrd, Spin, ShellApi, AlertDlg,Printers;

const
note= 'Note 1.1';
titulo= ' - '+note;
Aviso = 'Aviso '+note;

type
  TForm1 = class(TForm)
    dat: TRichEdit;
    MainMenu1: TMainMenu;
    Archivo1: TMenuItem;
    Nuevo1: TMenuItem;
    Abrir1: TMenuItem;
    Guardar1: TMenuItem;
    GuardarComo1: TMenuItem;
    N1: TMenuItem;
    Imprimir1: TMenuItem;
    N2: TMenuItem;
    Salir1: TMenuItem;
    Open: TOpenDialog;
    Save: TSaveDialog;
    Print: TPrintDialog;
    Edicin1: TMenuItem;
    Deshacer1: TMenuItem;
    N3: TMenuItem;
    Copiar1: TMenuItem;
    Cortar1: TMenuItem;
    Pegar1: TMenuItem;
    N4: TMenuItem;
    Buscar1: TMenuItem;
    SelecionarTodo1: TMenuItem;
    Buscar: TFindDialog;
    Insertar1: TMenuItem;
    Ver1: TMenuItem;
    Format1: TMenuItem;
    Ayuda1: TMenuItem;
    Acercade1: TMenuItem;
    Fuente1: TMenuItem;
    Font: TFontDialog;
    StatusBar1: TStatusBar;
    BarradeEstado1: TMenuItem;
    NoteBar: TPanel;
    sbNuevo: TSpeedButton;
    sbAbrir: TSpeedButton;
    sbGuardar: TSpeedButton;
    sbImprimir: TSpeedButton;
    sbCortar: TSpeedButton;
    sbCopiar: TSpeedButton;
    sbPegar: TSpeedButton;
    sbIzquierda: TSpeedButton;
    sbCentrar: TSpeedButton;
    sbDerecha: TSpeedButton;
    AD: TAlertDlg;
    procedure FormCreate(Sender: TObject);
    procedure datChange(Sender: TObject);
    procedure Salir1Click(Sender: TObject);
    procedure Nuevo1Click(Sender: TObject);
    procedure Abrir1Click(Sender: TObject);
    procedure Guardar1Click(Sender: TObject);
    procedure GuardarComo1Click(Sender: TObject);
    procedure Imprimir1Click(Sender: TObject);
    procedure Pegar1Click(Sender: TObject);
    procedure Deshacer1Click(Sender: TObject);
    procedure Copiar1Click(Sender: TObject);
    procedure Cortar1Click(Sender: TObject);
    procedure Buscar1Click(Sender: TObject);
    procedure BuscarFind(Sender: TObject);
    procedure SelecionarTodo1Click(Sender: TObject);
    procedure Fuente1Click(Sender: TObject);
    procedure MostrarPosicion;
    procedure datSelectionChange(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Acercade1Click(Sender: TObject);
    procedure sbNuevoClick(Sender: TObject);
    procedure sbAbrirClick(Sender: TObject);
    procedure BarradeEstado1Click(Sender: TObject);
    procedure sbGuardarClick(Sender: TObject);
    procedure sbImprimirClick(Sender: TObject);
    procedure sbCortarClick(Sender: TObject);
    procedure sbCopiarClick(Sender: TObject);
    procedure sbPegarClick(Sender: TObject);
    procedure sbIzquierdaClick(Sender: TObject);
    procedure sbCentrarClick(Sender: TObject);
    procedure sbDerechaClick(Sender: TObject);
    procedure NoteBarClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  strNombreArch: String;

implementation

uses ac;

{$R *.dfm}

procedure TForm1.MostrarPosicion;
begin
 StatusBar1.Panels[0].Text := Format( 'Fila: %d Columna %d',
   [dat.CaretPos.y+1, dat.CaretPos.x+1] );
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
dat.clear;
 Self.Caption:='Sin Titulo - '+note;
  strNombreArch:=ParamStr(1); //abre el archivo que se pasa como parametro en la linea de comandos
  if strNombreArch<>'' then begin
    dat.Lines.LoadFromFile(strNombreArch);
    Self.Caption:=strNombreArch+Titulo;
    dat.Modified:=FALSE;
    end;
    StatusBar1.Panels[1].Text:= DateToStr(Date);
    MostrarPosicion;
end;

procedure TForm1.datChange(Sender: TObject);
begin
dat.Modified:=true;
end;

procedure TForm1.Salir1Click(Sender: TObject);
begin
Close;
end;

procedure TForm1.Nuevo1Click(Sender: TObject);
begin
dat.Clear;
dat.Modified:=true;
Self.Caption:= 'Sin Titulo - '+note;
end;

procedure TForm1.Abrir1Click(Sender: TObject);
begin
if Open.Execute then begin
 strNombreArch:= Open.FileName;
 dat.Lines.LoadFromFile(strNombreArch);
 Self.Caption:=strNombreArch+titulo;
 dat.Modified:=true;
end;
end;
procedure TForm1.Guardar1Click(Sender: TObject);
begin
 if strNombreArch='' then begin //si no ha sido guardado antes
    if Save.Execute then begin
      strNombreArch:=Save.FileName;
      dat.Lines.SaveToFile(strNombreArch);
      dat.Modified:=FALSE;
      Self.Caption:=strNombreArch+titulo;
      end;
    end
  else begin  //si ya se guardo y se esta editando
    dat.Lines.SaveToFile(strNombreArch);
    dat.Modified:=FALSE;
    Self.Caption:=strNombreArch+titulo;
    end;
end;

procedure TForm1.GuardarComo1Click(Sender: TObject);
begin
if Save.Execute then
  begin
    strNombreArch:=Save.FileName;
    dat.Lines.SaveToFile(strNombreArch);
    dat.Modified:=FALSE;
    Self.Caption:=strNombreArch+titulo;
  end;
end;

procedure TForm1.Imprimir1Click(Sender: TObject);
Var
Impresora : TextFile;
N : Integer;
begin
If Print.Execute Then
Begin
AssignPrn (Impresora);
Rewrite (Impresora);
Printer.Canvas.Font := dat.Font;
For N := 0 to dat.Lines.Count -1 Do
Writeln (Impresora,dat.Lines [n]);
CloseFile (impresora);
End;
 end;

procedure TForm1.Pegar1Click(Sender: TObject);
begin
 Dat.PasteFromClipboard;
end;

procedure TForm1.Deshacer1Click(Sender: TObject);
begin
dat.Undo;
end;

procedure TForm1.Copiar1Click(Sender: TObject);
begin
  Dat.CopyToClipboard;
end;

procedure TForm1.Cortar1Click(Sender: TObject);
begin
 Dat.CutToClipboard
end;

procedure TForm1.Buscar1Click(Sender: TObject);
begin
Buscar.Execute;
end;

procedure TForm1.BuscarFind(Sender: TObject);
var I, J, PosReturn, SkipChars: Integer;
begin
 for I := 0 to dat.Lines.Count do
  begin
    PosReturn := Pos(Buscar.FindText, dat.Lines[I]);
    if PosReturn <> 0 then {encontrado!}
    begin
      SkipChars := 0;
      for J := 0 to I - 1 do
        SkipChars := SkipChars + Length(dat.Lines[J]);

      SkipChars := SkipChars + (I*2);
      SkipChars := SkipChars + PosReturn - 1;

      dat.SetFocus;
      dat.SelStart := SkipChars;
      dat.SelLength := Length(Buscar.FindText);
      Break;
    end
  else if MessageBox(0,'No se hallaron coincidencias...', Aviso, MB_TASKMODAL or MB_ICONEXCLAMATION or MB_OK)=MB_OK then begin Buscar.CloseDialog; Abort; end;

end;
 end;
procedure TForm1.SelecionarTodo1Click(Sender: TObject);
begin
 dat.SelectAll;
end;

procedure TForm1.Fuente1Click(Sender: TObject);
begin
if Font.Execute then begin
 dat.Font:=font.Font;
end;
 end;

procedure TForm1.datSelectionChange(Sender: TObject);
begin
 MostrarPosicion;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
Var
Boton : Integer;
begin
If dat.Modified = True Then
Begin
CanClose := False;
Boton:= AD.ShowModal('Alerta Note','Desea guardar los cambios?');
If Boton = IDYes Then
Begin
Guardar1Click (Sender);
CanClose := True;
End
Else
If Boton = IDNo Then
CanClose := True
Else
If Boton = IDCancel then
CanClose := False;
End;
end;

procedure TForm1.Acercade1Click(Sender: TObject);
begin
AboutBox.show;
end;

procedure TForm1.sbNuevoClick(Sender: TObject);
begin
dat.Clear;
dat.Modified:=true;
Self.Caption:= 'Sin Titulo - '+note;
end;

procedure TForm1.sbAbrirClick(Sender: TObject);
begin
if Open.Execute then begin
 strNombreArch:= Open.FileName;
 dat.Lines.LoadFromFile(strNombreArch);
 Self.Caption:=ExtractFileName(strNombreArch)+titulo;
 dat.Modified:=true;
 end;
end;

procedure TForm1.BarradeEstado1Click(Sender: TObject);
begin
NoteBar.Visible:=true;
end;

procedure TForm1.sbGuardarClick(Sender: TObject);
begin
if strNombreArch='' then begin //si no ha sido guardado antes
    if Save.Execute then begin
      strNombreArch:=Save.FileName;
      dat.Lines.SaveToFile(strNombreArch);
      dat.Modified:=FALSE;
      Self.Caption:=ExtractFileName(strNombreArch)+titulo;
      end;
    end
  else begin  //si ya se guardo y se esta editando
    dat.Lines.SaveToFile(strNombreArch);
    dat.Modified:=FALSE;
    Self.Caption:=ExtractFileName(strNombreArch)+titulo;
    end;
end;

procedure TForm1.sbImprimirClick(Sender: TObject);
Var
Impresora : TextFile;
N : Integer;
begin
If Print.Execute Then
Begin
AssignPrn (Impresora);
Rewrite (Impresora);
Printer.Canvas.Font := dat.Font;
For N := 0 to dat.Lines.Count -1 Do
Writeln (Impresora,dat.Lines [n]);
CloseFile (impresora);
End;
 end;

procedure TForm1.sbCortarClick(Sender: TObject);
begin
dat.CutToClipboard;
end;

procedure TForm1.sbCopiarClick(Sender: TObject);
begin
dat.CopyToClipboard;
end;

procedure TForm1.sbPegarClick(Sender: TObject);
begin
dat.PasteFromClipboard;
end;

procedure TForm1.sbIzquierdaClick(Sender: TObject);
begin
Dat.Paragraph.Alignment:=taLeftJustify;
end;

procedure TForm1.sbCentrarClick(Sender: TObject);
begin
Dat.Paragraph.Alignment:=taCenter;
end;

procedure TForm1.sbDerechaClick(Sender: TObject);
begin
Dat.Paragraph.Alignment:=taRightJustify;
end;

procedure TForm1.NoteBarClick(Sender: TObject);
begin
NoteBar.Visible:=false;
end;

end.
